import { JSX } from 'react';
import { LayerText } from '@/types/models';
import { Icon } from '@/shared/Icon';

interface LayersDrawerTextItemProps {
  layerText: LayerText;
}

export const LayersDrawerTextItem = ({
  layerText,
}: LayersDrawerTextItemProps): JSX.Element | null => {
  return (
    <div className="flex min-h-[24px]  gap-2">
      <Icon name="text" className="shrink-0" />
      <span className="truncate">{layerText.notes}</span>
    </div>
  );
};
