import { createSlice } from '@reduxjs/toolkit';
import { LAYERS_STATE_INITIAL_MOCK } from '@/redux/layers/layers.mock';
import {
  getLayerImageReducer,
  getLayerTextReducer,
  getLayersForModelReducer,
  layerAddImageReducer,
  layerAddTextReducer,
  layerDeleteImageReducer,
  layerUpdateImageReducer,
  setLayerVisibilityReducer,
  setDrawLayerReducer,
  setLayerToInactiveReducer,
  setLayerToActiveReducer,
} from '@/redux/layers/layers.reducers';

export const layersSlice = createSlice({
  name: 'layers',
  initialState: LAYERS_STATE_INITIAL_MOCK,
  reducers: {
    setLayerVisibility: setLayerVisibilityReducer,
    setLayerToInactive: setLayerToInactiveReducer,
    setLayerToActive: setLayerToActiveReducer,
    layerAddImage: layerAddImageReducer,
    layerUpdateImage: layerUpdateImageReducer,
    layerDeleteImage: layerDeleteImageReducer,
    layerAddText: layerAddTextReducer,
    setDrawLayer: setDrawLayerReducer,
  },
  extraReducers: builder => {
    getLayersForModelReducer(builder);
    getLayerImageReducer(builder);
    getLayerTextReducer(builder);
  },
});

export const {
  setLayerVisibility,
  setLayerToInactive,
  setLayerToActive,
  layerAddImage,
  layerUpdateImage,
  layerDeleteImage,
  layerAddText,
  setDrawLayer,
} = layersSlice.actions;

export default layersSlice.reducer;
